var unselect = require("./unselect");

module.exports = {
  add          : add,
  addBefore    : addBefore,
  insert       : insert,
  replace      : replace,
  remove       : remove
};

function add(element, child, vars){
  element.appendChild(unselect(child, vars));
}

function addBefore(element, child, varsOrRef, ref){
  element.insertBefore(unselect(child, varsOrRef), pick(element, arguments[ arguments.length - 1 ]));
}

function insert(element, parent){
  add(pick(document, parent), element);
}

function pick(parent, child){
  if ( typeof child == 'string') {
     return parent.querySelector(child);
  }

  return unselect(child);
}

function replace(element, target, replacement){
  element.replaceChild(unselect(replacement), pick(element, target));
}

function remove(element, child){
  if (arguments.length == 1) {
    return element.parentNode.removeChild(element);
  }
  element.removeChild(pick(element, child));
}
